<?php
require_once "/opt/loxberry/libs/phplib/loxberry_system.php";

$file_config = $lbpconfigdir . '/reolink.ini';
$config = json_decode(file_get_contents($file_config) , true);
$file_log = $lbplogdir . '/reolink_md.log';
//Get arguments
$filters = array_fill(0, 2, null);
for ($i = 1;$i < $argc;$i++)
{
    $filters[$i - 1] = $argv[$i];
}
$nr = $filters[0];
$do = $filters[1];
$debug = $config['debug']['debug'];

function write2log($debug, $logfile, $message)
{	
	if ($debug == 1) {
	$dt = date("Y-m-d H:i:s");
    $message_log = $dt . ' - ' . $message;
    file_put_contents($logfile, PHP_EOL . $message_log, FILE_APPEND);
	}
}

if (empty($nr) or empty($do))
{
	$message='Camera number or Do is missing!';
	write2log($debug, $file_log, $message);	
    print ($message_log . '\n');
    exit();
}

$cam_ip = $config['cam_' . $nr]['ip'];
$cam_user = $config['cam_' . $nr]['username'];
$cam_pass = $config['cam_' . $nr]['password'];
$server_ip = $config['miniserver']['ip'];
$server_port = $config['miniserver']['port'];
$beat_period = 2;

$motion_detected_p = 1;
$motion_detected_v = 1;
$motion_detected_d = 1;
$motion_detected_md = 1;

if ($debug == 1) {
$message='--------------------------------------------------------------------';
write2log($debug, $file_log, $message);	
$message='Startup Service '.$do.' / clean Motion-States';
write2log($debug, $file_log, $message);	
}
//Create UDP Socket
if ($socket = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP))
{
    while (1)
    {
        
        $response_ok = 0;
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => 'http://' . $cam_ip . '/cgi-bin/api.cgi?cmd='.$do.'&user=' . $cam_user . '&password=' . $cam_pass,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_POSTFIELDS => '[{"cmd":"'.$do.'","param":{"channel":0}}]',
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json'
            ) ,
        ));
        $response = curl_exec($curl);
        curl_close($curl);
        $response_arr = json_decode($response, true);
		//print_r($response_arr);
	
        if ($response_arr['0']['code'] == 0)
            {
                $response_ok = 1;
            }
        if ($response_ok == 1)
        {
            if ($do == 'GetMdState'){
			if ($response_arr['0']['value']['state'] == 1 && $motion_detected_md == 0)
            {
                $message = "reolink:" . $nr . " motion_detection:1";
                socket_sendto($socket, $message, strlen($message) , 0, $server_ip, $server_port);
                $motion_detected_md = 1;
				write2log($debug, $file_log, $message);	
            }
            elseif ($response_arr['0']['value']['state'] == 0 && $motion_detected_md == 1)
            {
                $message = "reolink:" . $nr . " motion_detection:0";
                socket_sendto($socket, $message, strlen($message) , 0, $server_ip, $server_port);
                $motion_detected_md = 0;
				write2log($debug, $file_log, $message);	
            }
			
			}
			if ($do == 'GetAiState'){
			if ($response_arr['0']['value']['people']['alarm_state'] == 1 && $motion_detected_p == 0)
            {
                $message = "reolink:" . $nr . " people:1";
                socket_sendto($socket, $message, strlen($message) , 0, $server_ip, $server_port);
                $motion_detected_p = 1;
				write2log($debug, $file_log, $message);	
            }
            elseif ($response_arr['0']['value']['people']['alarm_state'] == 0 && $motion_detected_p == 1)
            {
                $message = "reolink:" . $nr . " people:0";
                socket_sendto($socket, $message, strlen($message) , 0, $server_ip, $server_port);
                $motion_detected_p = 0;
				write2log($debug, $file_log, $message);	
            }

            if ($response_arr['0']['value']['vehicle']['alarm_state'] == 1 && $motion_detected_v == 0)
            {
                $message = "reolink:" . $nr . " vehicle:1";
                socket_sendto($socket, $message, strlen($message) , 0, $server_ip, $server_port);
                $motion_detected_v = 1;
				write2log($debug, $file_log, $message);	
            }
            elseif ($response_arr['0']['value']['vehicle']['alarm_state'] == 0 && $motion_detected_v == 1)
            {
                $message = "reolink:" . $nr . " vehicle:0";
                socket_sendto($socket, $message, strlen($message) , 0, $server_ip, $server_port);
                $motion_detected_v = 0;
				write2log($debug, $file_log, $message);	
            }

            if ($response_arr['0']['value']['dog_cat']['alarm_state'] == 1 && $motion_detected_d == 0)
            {
                $message = "reolink:" . $nr . " dog_cat:1";
                socket_sendto($socket, $message, strlen($message) , 0, $server_ip, $server_port);
                $motion_detected_d = 1;
				write2log($debug, $file_log, $message);	
            }
            elseif ($response_arr['0']['value']['dog_cat']['alarm_state'] == 0 && $motion_detected_d == 1)
            {
                $message = "reolink:" . $nr . " dog_cat:0";
                socket_sendto($socket, $message, strlen($message) , 0, $server_ip, $server_port);
                $motion_detected_d = 0; 
				write2log($debug, $file_log, $message);	
            }
			}
        }

            if ($response_ok == 0)
            {
                $message_log = $response;
                write2log($debug, $file_log, $message_log);	;
                exit();
            }
			
        sleep($beat_period);
    }
}
else
{
    if ($debug == 1)
    {
        $message_log = $dt . ' - cant create UDP socket - please check MiniServer IP and PORT';
        file_put_contents($file_log, PHP_EOL . $message_log, FILE_APPEND);
    }
}
?>

