#!/bin/bash

config=$LBPCONFIG"/reolink/reolink.ini"

if [ $1 == "start" ] || [ $1 == "restart" ] || [ $1 == "stop" ]; then
sudo systemctl $1 $2
fi

if [ $1 == "set_services" ]; then
#Stop all services
for num in {1..5}
do
sudo systemctl stop reolink_motion_cam_$num.service
done

#Create Services
for num in {1..5}
do
  service=$(jq '.cam_'$num' .service' $config | tr -d '"')
  if [ $service != 0 ]; then
  active=1
	  if [ $service == 1 ]; then
		do="GetAiState"
	  fi
	  if [ $service == 2 ]; then
		do="GetMdState"
	  fi
  else
  active=0
  fi

  if [ $active == 1 ]; then
  cam_name=$(jq '.cam_'$num' .name' $config | tr -d '"')
  echo "set service for Cam: "$cam_name  
	serv_files="/etc/systemd/system/reolink_motion_cam_"$num".service"
	echo "[Unit]" > $serv_files
	echo "Description=Reolink Motion detection Cam "$cam_name >> $serv_files
	echo "Requires=network.target" >> $serv_files
	echo "After=loxberry.service" >> $serv_files
	echo "" >> $serv_files
	echo "[Service]" >> $serv_files
	echo "Type=idle" >> $serv_files
	echo "ExecStart="/usr/bin/php $LBPBIN"/reolink/reo_m.php "$num $do >> $serv_files
	echo "Environment="TERM=dumb"" >> $serv_files
	echo "Restart=on-failure" >> $serv_files
	echo "RestartSec=60" >> $serv_files
	echo "StandardOutput=journal" >> $serv_files
	echo "StandardError=journal" >> $serv_files
	echo "" >> $serv_files
	echo "[Install]" >> $serv_files
	echo "WantedBy=multi-user.target" >> $serv_files
	sudo systemctl enable reolink_motion_cam_$num.service
  else
	sudo systemctl disable reolink_motion_cam_$num.service & 
	rm -rf /etc/systemd/system/reolink_motion_cam_$num.service &
  fi
done
	sudo systemctl daemon-reload
for num in {1..5}
do
  service=$(jq '.cam_'$num' .service' $config | tr -d '"')
  if [ $service != 0 ]; then
  sudo systemctl restart reolink_motion_cam_$num.service
  fi

done
fi	
