<?php
require_once "/opt/loxberry/libs/phplib/loxberry_system.php";
//error_reporting(E_ALL);
$file_config = $lbpconfigdir . '/reolink.ini';
$config = json_decode(file_get_contents($file_config) , true);
$file_log = $lbplogdir . '/reolink_cmd.log';

$cam = ($_GET["cam"]);
$cmd = ($_GET["cmd"]);
$set = ($_GET["set"]);
$bri = ($_GET["bri"]);
$ch = ($_GET["ch"]);
$id = ($_GET["id"]);
$speed = ($_GET["speed"]);

$cam_ip = $config['cam_' . $cam]['ip'];
$cam_https = $config['cam_' . $cam]['https'];
$cam_user = $config['cam_' . $cam]['username'];
$cam_pass = $config['cam_' . $cam]['password'];
$server_ip = $config['miniserver']['ip'];
$server_port = $config['miniserver']['port'];
$debug = $config['debug']['debug'];

$dt = date("Y-m-d H:i:s");

if (empty($cam)) {
    if ($debug == 1) {
        $message = $dt . ' - Cam Number is missing';
        file_put_contents($file_log, PHP_EOL . $message, FILE_APPEND);
        echo $message;
    }
    exit();
}
if (empty($cmd)) {
    $message = $dt . ' - Command (cmd) is missing';
    if ($debug == 1) {
        file_put_contents($file_log, PHP_EOL . $message, FILE_APPEND);
    }
    echo $message;
    exit();
}
if ($cmd == 'SetWhiteLed') {
    if (is_null($set) or is_null($bri)) {
        if ($debug == 1) $message = $dt . ' - Command ' . $cmd . ' : &set= and &bri= is needed'; {
            file_put_contents($file_log, PHP_EOL . $message, FILE_APPEND);
        }
        echo $message;
        exit();
    }
}
if ($cmd == 'SetDevName' || $cmd == 'SetIrLights' || $cmd == 'SetRecV20' || $cmd == 'SetPowerLed' || $cmd == 'AudioAlarmPlay') {
    if (empty($set)) {
        $message = $dt . ' - Command ' . $cmd . ' : &set= is needed';
        if ($debug == 1) {
            file_put_contents($file_log, PHP_EOL . $message, FILE_APPEND);
        }
        echo $message;
        exit();
    }
}

if ($cmd == 'ToPos') {
    if (empty($id)) {
        $message = $dt . ' - Command ' . $cmd . ' : &id= is needed';
        if ($debug == 1) {
            file_put_contents($file_log, PHP_EOL . $message, FILE_APPEND);
        }
        echo $message;
        exit();
    }
}

if ($cmd == 'StartPatrol' || $cmd == 'StopPatrol' || $cmd == 'Auto') {
    if (empty($speed)) {
        $message = $dt . ' - Command ' . $cmd . ' : &speed= is needed';
        if ($debug == 1) {
            file_put_contents($file_log, PHP_EOL . $message, FILE_APPEND);
        }
        echo $message;
        exit();
    }
}

function startURLCheck($url, $parm) {
    $curl = curl_init();
    curl_setopt_array($curl, array(
        CURLOPT_URL => $url,
        CURLOPT_SSL_VERIFYHOST => 0,
        CURLOPT_SSL_VERIFYPEER => 0,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'GET',
        CURLOPT_POSTFIELDS => $parm,
        CURLOPT_HTTPHEADER => array(
            'Content-Type: application/json'
        ) ,
    ));
    return curl_exec($curl);
}

function generateRandomString($length = 8) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $charactersLength = strlen($characters);
    $randomString = '';

    for ($i = 0;$i < $length;$i++) {
        $randomString .= $characters[random_int(0, $charactersLength - 1) ];
    }
    return $randomString;
}

if ($cmd == get_token) {
    $url = 'http://' . $cam_ip . '/cgi-bin/api.cgi?cmd=login';
    $parm = '[{"cmd":"Login","param":{"User":{"Version": "0","userName":"admin","password":"' . $cam_pass . '"}}}]';
    $response = startURLCheck($url, $parm);
    $response = json_decode($response, true);
    $token = $response['0']['value']['Token']['name'];
    echo $token;
}

switch ($cmd) {
    case "GetAiState":
        $parm = '[{"cmd":"GetAiState","param":{"channel":0}}]';
    break;
    case "GetAbility":
        $parm = '[{"cmd":"GetAbility","param":{"User":{"userName":"admin"}}}]';
    break;
    case "GetDevInfo":
        $parm = '[{"cmd":"GetDevInfo"}]';
    break;
    case "GetDevName":
        $parm = '[{"cmd": "GetDevName","param": {"channel":0}}]';
    break;
    case "GetNetPort":
        $parm = '[{"cmd":"GetNetPort","action":1}]';
    break;
    case "SetDevName":
        $parm = '[{"cmd": "SetDevName","param": {"DevName": {"name": "' . $set . '"}}}]';
    break;
    case "GetHddInfo":
        $parm = '[{"cmd":"GetHddInfo"}]';
    break;
    case "Format":
        $parm = '[{"cmd": "Format","param": {"HddInfo": {"id": [0]}}}]';
    break;
    case "Reboot":
        $parm = '[{"cmd":"Reboot"}]';
    break;
    case "Getchannelstatus":
        $parm = '[{"cmd": "Getchannelstatus"}]';
    break;
    case "GetIrLights":
        $parm = '[{"cmd":"GetIrLights","action":1,"param": {"channel": 0}}]';
    break;
    case "SetIrLights":
        $parm = '[{"cmd": "SetIrLights","action": 0,"param": {"IrLights": {"channel": 0,"state": "' . $set . '"}}}]';
    break;
    case "GetPowerLed":
        $parm = '[{"cmd":"GetPowerLed","action":1,"param": {"channel": 0}}] ';
    break;
    case "SetPowerLed":
        $parm = '[{"cmd":"SetPowerLed","param":{"PowerLed":{"state":"' . $set . '","channel":0}}}]';
    break;
    case "GetWhiteLed":
        $parm = '[{"cmd": "GetWhiteLed","action": 0,"param": {"channel": 0}}] ';
    break;
    case "SetWhiteLed":
        $parm = '[{"cmd": "GetWhiteLed","action": 0,"param": {"channel": 0}}] ';
        $url = 'http://' . $cam_ip . '/cgi-bin/api.cgi?cmd=' . $cmd . '&user=' . $cam_user . '&password=' . $cam_pass;
        $response = startURLCheck($url, $parm);
        $response = json_decode($response, true);
        $parm = '[{"cmd": "SetWhiteLed","param": {"WhiteLed": {"state": ' . $set . ',"channel": 0,"mode": ' . $response['0']['value']['WhiteLed']['mode'] . ',"bright": ' . $bri . '}}}]';
    break;
    case "AudioAlarmPlay":
        $parm = '[{"cmd": "AudioAlarmPlay","action": 0,"param": {"alarm_mode": "manu","manual_switch":' . $set . ',"channel": 0}}]';
    break;
    case "SetRecV20":
        $parm = '[{"cmd": "SetRecV20","action":0,"param":{"Rec":{"channel":0,"enable":' . $set . '}}}]';
    break;
    case "ToPos":
        if (empty($speed)) {
            $speed = 32;
        }
        $parm = '[{"cmd":"PtzCtrl","param":{"channel":0,"op":"ToPos","id":' . $id . ',"speed":' . $speed . '}}]';
    break;
        //RLC-423, RLC-423W, RLC-523WA, RLC-823 Series (RLC-823A, RLC-823A 16X, RLC-823S1, RLC-823S2, RLC-823S1W
        
    case "StartPatrol":
        if (empty($speed)) $parm = '[{"cmd":"PtzCtrl","param":{"channel":0,"op":"StartPatrol","speed":' . $speed . '}}';
        break;
    case "StopPatrol":
        if (empty($speed)) $parm = '[{"cmd":"PtzCtrl","param":{"channel":0,"op":"StopPatrol","speed":' . $speed . '}}';
        break;
    case "Auto":
        if (empty($speed)) $parm = '[{"cmd":"PtzCtrl","param":{"channel":0,"op":"Auto","speed":' . $speed . '}}';
        break;
    default:
        echo "ERROR";
    }

    if ($cam_https == 1) {
        $https_url = 'https://';
    }
    else {
        $https_url = 'http://';
    }

    $url = $https_url . $cam_ip . '/cgi-bin/api.cgi?cmd=' . $cmd . '&user=' . $cam_user . '&password=' . $cam_pass;
    $response = startURLCheck($url, $parm);
    echo $response;

    if ($debug == 1) {
        $message = $dt . ' - Command ' . $cmd . ' result:' . $response;
        file_put_contents($file_log, PHP_EOL . $message, FILE_APPEND);
        echo $message;
    }
?>